#ifndef DOCPROPSDIALOG_H	// -*- c++ -*-
#define DOCPROPSDIALOG_H
///
// Copyright (C) 2002, 2003, Fredrik Arnerup & Rasmus Kaj, See COPYING
///
#include "widget/dialogwrap.h"

class Document_View;
namespace Gtk {
  class CheckButton;
  class RadioButton;
  class Button;
  class VBox;
  class Combo;
};
class File_Entry;
class Spinner;

class Doc_Props_Dialog : public DialogWrap {
public:
  Doc_Props_Dialog();
  void modify(Document_View *_view) {show_it(_view, false);}
  void create(Document_View *_view) {show_it(_view, true);};

private:
  Gtk::CheckButton *template_button;
  Gtk::RadioButton *portrait_button, *landscape_button,
    *single_sided_button, *double_sided_button;
  Gtk::Button *ok_button, *create_button;
  Gtk::VBox *format_box;
  Gtk::Combo *paper_size;
  File_Entry *file_entry;
  Spinner *first_page;
  bool new_document;
  Document_View *view;

  void show_raise() {}
  void update_mode();
  void show_it(Document_View *_view, bool create_new);
  void on_response(int response_id);
};

#endif
