#ifndef METABASE_H		// -*- c++ -*-
#define METABASE_H
///
// Copyright (C) 2002, 2003, Fredrik Arnerup & Rasmus Kaj, See COPYING
///
#include "pagent.h"
#include "propbase.h"

/**
 * An interface to get information about frame kinds.  To invent a new kind of
 * frame, simply implement this interface and the objects it returns.
 */
class MetaBase {
public:
  // May NOT return 0, but can throw an exception on any error.
  virtual Pagent* load(const xmlpp::Element& node, Group* parent) = 0;

  virtual PropBase* getProp() = 0;
};

#endif
